TransactionPhase
Date: 2015-09-11

javax.enterprise.event

## Enum TransactionPhase

- java.lang.Object
- - java.lang.Enum<TransactionPhase>
  - - javax.enterprise.event.TransactionPhase

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<TransactionPhase>

      public enum TransactionPhase
      extends java.lang.Enum<TransactionPhase>

  Distinguishes the various kinds of transactional observer methods from regular observer methods which are notified immediately.

  Transactional observer methods are observer methods which receive event notifications during the before or after completion phase of the transaction in which the event was fired. If no transaction is in progress when the event is fired, they are notified at the same time as other observers.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `AFTER_COMPLETION` Identifies an after completion observer method, called during the after completion phase of the transaction.
    `AFTER_FAILURE` Identifies an after failure observer method, called during the after completion phase of the transaction, only when the transaction fails.
    `AFTER_SUCCESS` Identifies an after success observer method, called during the after completion phase of the transaction, only when the transaction completes successfully.
    `BEFORE_COMPLETION` Identifies a before completion observer method, called during the before completion phase of the transaction.
    `IN_PROGRESS` Identifies a regular observer method, called when the event is fired.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static TransactionPhase` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static TransactionPhase[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### IN_PROGRESS

          public static final TransactionPhase IN_PROGRESS

      Identifies a regular observer method, called when the event is fired.

    - #### BEFORE_COMPLETION

          public static final TransactionPhase BEFORE_COMPLETION

      Identifies a before completion observer method, called during the before completion phase of the transaction.

    - #### AFTER_COMPLETION

          public static final TransactionPhase AFTER_COMPLETION

      Identifies an after completion observer method, called during the after completion phase of the transaction.

    - #### AFTER_FAILURE

          public static final TransactionPhase AFTER_FAILURE

      Identifies an after failure observer method, called during the after completion phase of the transaction, only when the transaction fails.

    - #### AFTER_SUCCESS

          public static final TransactionPhase AFTER_SUCCESS

      Identifies an after success observer method, called during the after completion phase of the transaction, only when the transaction completes successfully.

  - ### Method Detail

    - #### values

          public static TransactionPhase[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (TransactionPhase c : TransactionPhase.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static TransactionPhase valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null